<html>
<head>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<style>
    .debug {
        display: none;
    }
</style>
</head>
<body>
<p id="intro-text">Press button on controller to connect.</p>
<div id="axes" style="display: flex; flex-direction: column;">
</div>
<script>

const apiRoot = "/";
const moveEndpoint = "api/v2/actions/stage/move/";
const imageEndpoint = "api/v2/actions/camera/capture/";
const autofocusEndpoint = "api/v2/actions/camera/capture/";

var mapping = {};

const tick = 100; //tick size in ms
const motorSpeedXY = 600; //~600 steps/s
const motorSpeedZ = 600; //assume its the same for now, also how does this work in delta?
const axisZeroThreshold = 0.05;
const limitConnections = 6; //browsers limit the number of connections and will queue requests, if the microscope takes too long to respond, the requests will be queued for several seconds after the stick is released, we drop requests instead

var currentConnections = 0;

function move(xAxis, yAxis, zAxis)
{
    const maxMoveXY = tick/1000.0 * motorSpeedXY;
    const maxMoveZ = tick/1000.0 * motorSpeedZ;
    if (currentConnections >= limitConnections)
    {
        console.log("Move request dropped due to connection limit");
        return false;
    }
    currentConnections++;
    $.ajax({
            type: "POST",
            dataType: "JSON",
            contentType: "application/json",
            url: apiRoot + moveEndpoint,
            data: JSON.stringify({
                "absolute": false,
                "x": Math.round(xAxis * maxMoveXY),
                "y": Math.round(yAxis * maxMoveXY),
                "z": Math.round(zAxis * maxMoveZ),
            })
    }).fail(function(data, textStatus, jqXHR){
        console.log("Move request failed: " + textStatus);
    }).always(function(){
        currentConnections--;
    });
}

var inCapture = false;
function captureImage()
{
    const maxMoveXY = tick/1000.0 * motorSpeedXY;
    const maxMoveZ = tick/1000.0 * motorSpeedZ;
    if (inCapture)
        return false;

    inCapture = true;
    $.ajax({
            type: "POST",
            dataType: "JSON",
            contentType: "application/json",
            url: apiRoot + imageEndpoint,
            data: ""
    }).fail(function(data, textStatus, jqXHR){
        console.log("Capture request failed: " + textStatus);
    }).always(function(){
        inCapture = false;
    });
}

var inAutofocus = false;
function autofocusImage()
{
    const maxMoveXY = tick/1000.0 * motorSpeedXY;
    const maxMoveZ = tick/1000.0 * motorSpeedZ;
    if (inAutofocus)
        return false;

    inAutofocus = true;
    $.ajax({
            type: "POST",
            dataType: "JSON",
            contentType: "application/json",
            url: apiRoot + autofocusEndpoint,
            data:""
    }).fail(function(data, textStatus, jqXHR){
        console.log("Autofocus request failed: " + textStatus);
    }).always(function(){
        inAutofocus = false;
    });
}

function loadMapping()
{
    const storedMapping = localStorage.getItem("controllerMapping");
    if (storedMapping === null)
        return;
    mapping = JSON.parse(storedMapping);
    for (const [id, axis] of Object.entries(mapping))
    {
        let select = $("#mapping_" + id);
        if (select != null)
        {
            select.val(axis);
        }
    }
}

function updateMapping()
{
    updated = {};
    for (const mappingConfigSelect of document.getElementsByClassName("mapping-config"))
    {
       if (mappingConfigSelect.value != "")
                updated[(mappingConfigSelect.dataset.type == "axis" ? "a" : "b") + "_" + mappingConfigSelect.dataset.gamepad + "_" + mappingConfigSelect.dataset.axis] = mappingConfigSelect.value
    }
    mapping = updated;

    localStorage.setItem("controllerMapping", JSON.stringify(mapping));
}

function axisSelect(gamepadId, axisId)
{
    return `<select class="mapping-config" id="mapping_a_${gamepadId}_${axisId}" data-gamepad=${gamepadId} data-axis=${axisId} data-type=axis>
                        <option value>-</option>
                        <option value=x>X</option>
                        <option value=x>Y</option>
                        <option value=z>Z</option>
            </select>`;
}

function buttonSelect(gamepadId, axisId)
{
    return `<select class="mapping-config" id="mapping_b_${gamepadId}_${axisId}" data-gamepad=${gamepadId} data-axis=${axisId} data-type=button>
                        <option value>-</option>
                        <option value=image>Capture Image</option>
                        <option value=autofocus>Autofocus</option>
            </select>`;
}

function axisRow(gamepadId, axisId, type="a")
{
    let id = type + "_" + gamepadId + "_" + axisId;
    return `<label><span class="debug">${id}</span><progress id="${id}"></progress><input type=number size=4 disabled=disabled class="debug" id="raw_${id}"></disabled>` +
                    (type == "a" ? axisSelect(gamepadId, axisId) : buttonSelect(gamepadId, axisId)) + `</label>`;
}

function updateButtons()
{
    for (const gamepad of navigator.getGamepads()) {
      if (!gamepad) continue;
      for (const [index, button] of gamepad.buttons.entries()) {
        let id = "b_" + gamepad.index + "_" + index;
        $("#" + id).val(button.value);
        if (!button.pressed)
            continue;
        if (id in mapping)
        {
            if (mapping[id] == "image")
                captureImage();
            else if (mapping[id] == "autofocus")
                autofocus();
        }
      }
    }
    requestAnimationFrame(updateButtons);
}

function updateAxes() {
    let moveBy = {"x": 0, "y": 0, "z": 0};
    let shouldMove = false;
    for (const gamepad of navigator.getGamepads()) {
        if (!gamepad) continue;
        for (const [index, axis] of gamepad.axes.entries()) {
            let id = "a_" + gamepad.index + "_" + index;
            document.getElementById(id).value = axis * 0.5 + 0.5;
            document.getElementById("raw_" + id).value = axis
            if (Math.abs(axis) > axisZeroThreshold && id in mapping)
            {
                moveBy[mapping[id]] += axis;
                shouldMove = true;
            }
        }
    }
    if (shouldMove)
        move(moveBy["x"], moveBy["y"], moveBy["z"]);
}


$(document).ready(function(){
    window.addEventListener('gamepadconnected', (event) => {
        const output = document.getElementById('axes');
        output.innerHTML = ''; // clear the output

        for (const gamepad of navigator.getGamepads()) {
          if (!gamepad) continue;
          for (const [index, axis] of gamepad.axes.entries()) {
            output.insertAdjacentHTML(
             'beforeend',
              axisRow(gamepad.index, index)
            );
          }

          for (const [index, axis] of gamepad.buttons.entries()) {
            output.insertAdjacentHTML(
             'beforeend',
              axisRow(gamepad.index, index, "b")
            );
          }
        }
        $(".mapping-config").on("change", updateMapping);
        setInterval(updateAxes, 100);
        requestAnimationFrame(updateButtons);
        $("#intro-text").hide();
        loadMapping();

    });
});
</script>
</body>